--====================================================================================================================
--== Sharp MZ-800 vga konvertor pro hardware V1								     DL2012 ==
--====================================================================================================================
--== verze h1.f3.15											 	    ==
--====================================================================================================================
--== Zdrojovy kod je mi uplne volny :-))									    ==
--== Veskere sireni a pozmenovani je povoleno									    ==
--====================================================================================================================
library IEEE;
use IEEE.std_logic_1164.ALL;
use IEEE.std_logic_arith.ALL;
use IEEE.std_logic_unsigned.ALL;
entity VgaConv is port (
CLKMZ : in std_logic;
MZRGBI : in std_logic_vector(3 downto 0);
MZVSYNC : in std_logic;
STOP : in std_logic;
CLK40 : in std_logic;
RAMADR : out std_logic_vector(17 downto 0);
RAMDAT : inout std_logic_vector(15 downto 0);
RAMWRT : out std_logic;
VGARGBI : out std_logic_vector(3 downto 0);
VGAHSYNC : out std_logic;
VGAVSYNC : out std_logic);
end VgaConv;
architecture rtl of VgaConv is
signal a0 : std_logic;
signal a1 : std_logic_vector(15 downto 0);
signal a2 : std_logic;
signal a3 : std_logic_vector(5 downto 0);
signal a4 : std_logic_vector(10 downto 0);
signal a5 : std_logic;
signal a6 : std_logic;
signal a7 : std_logic;
signal a8 : std_logic_vector(7 downto 0);
signal a9 : std_logic;
signal b0 : std_logic_vector(9 downto 0);
signal b1 : std_logic_vector(8 downto 0);
signal b2 : std_logic;
signal b3 : std_logic;
signal b4 : std_logic;
signal b5 : std_logic_vector(3 downto 0);
signal b6 : std_logic_vector(15 downto 0);
signal b7 : std_logic_vector(10 downto 0);
signal b8 : std_logic;
begin
VGARGBI <= "0000" when a2='0' else b6(3 downto 0);
process (CLKMZ) begin
if CLKMZ'event and CLKMZ='1' then
b4 <= MZVSYNC;
if b4='0' and MZVSYNC='1' then
if b1 < 290 then
a4 <= "11100111101";
b1 <= "000001100";
b3 <= '1';
else
a4 <= "11001011101";
b1 <= "111110010";
b3 <= '0';
end if;
if STOP='1' then
a6 <= not a6;
end if;
end if;
a9 <= '0';
a4(1 downto 0) <= a4(1 downto 0) +'1';
if a4(1 downto 0)=0 then
a8(3 downto 0) <= MZRGBI;
elsif a4(1 downto 0)=1 then
a8(7 downto 4) <= MZRGBI;
elsif a4(1 downto 0)=2 then
a1(11 downto 0) <= MZRGBI & a8;
elsif a4(1 downto 0)=3 then
a1(15 downto 12) <= MZRGBI;
a4(10 downto 2) <= a4(10 downto 2)+'1';
a9 <= not a4(10);
end if;
if (a4=1135 and b3='0') or (a4=911 and b3='1') then
a4 <= (others=>'0');
b1 <= b1 + 1;
end if;
end if;
end process;
RAMADR <= a6 & b1(8 downto 0) & a4(9 downto 2) when a7='0' else a5 & b0(9 downto 7) & a3 & b7(9 downto 6) & b5;
RAMDAT <= a1 when a7='0' else "ZZZZZZZZZZZZZZZZ";
RAMWRT <= a7;
process (CLK40) begin
if CLK40'event and CLK40='0' then
if b0=0 then
b8 <= '1';
elsif b0=600 then
b8 <= '0';
elsif b0=601 then
VGAVSYNC <= '1';
elsif b0=605 then
VGAVSYNC <= '0';
end if;
b2 <= '0';
if b7=7 and b8='1' then
a2 <= '1';
elsif b7=807 then
a2 <= '0';
elsif b7=847 then
VGAHSYNC <= '1';
elsif b7=975 then
VGAHSYNC <= '0';
end if;
a7 <= '1';
if b7(1 downto 0)=3 then
b6 <= RAMDAT;
else
b6(11 downto 0) <= b6(15 downto 4);
if b7(1 downto 0)=0 then
b5 <= b7(5 downto 2);
a3 <= b0(6 downto 1);
if b3='0' then
if b0(9 downto 1)<5 then
a3 <= "000101";
elsif b0(9 downto 1)>290 then
a3 <= "100010";
end if;
else
if b7(9 downto 2)<7 then
b5 <= "0111";
elsif b7(9 downto 2)>193 then
b5 <= "0001";
end if;
if b0(9 downto 1)<26 then
a3 <= "011010";
elsif b0(9 downto 1)>266 then
a3 <= "001010";
end if;
end if;
end if;
end if;
a0 <= a9;
if b7=1055 then
b7 <= (others=>'0');
if b0=627 then
b0 <= (others=>'0');
a5 <= not a6;
else
b0 <= b0 + '1';
end if;
else
b7 <= b7 + '1';
end if;
if a0='1' and a9='0' and b7(1 downto 0)=2 then
b2 <= '1';
elsif (a0='1' and a9='0') or b2='1' then
a7 <= '0';
end if;
end if;
end process;
end rtl;
